{$M+,E+}        { turn on modular compilation, external symbols }

program fmtutils;

CONST

   DriveA = 0;          { Drive A is 0... }
   DriveB = 1;          { Drive B is 1... }

   SngSid40 = 0;        { Types of drive formats available... }
   DblSid40 = 1;        { same as ProtoBoot function in XBIOS }
   SngSid80 = 2;
   DblSid80 = 3;

   RetStat = -1;        { for WrtVer below... }
   Off = 0;
   On = 1;

TYPE

   Flop_Typ  = DriveA..DriveB;          { drives A and B only, thanks... }
   Fmt_Typ = SngSid40..DblSid80;        { type codes...                  }
   VerTyp   = RetStat..On;              { for wrtver func..              }
   Drv_Range = 0..15;                   { valid drive ranges...          }

FUNCTION  is_drive( dnum : INTEGER )     : BOOLEAN; C;
FUNCTION  verify( f: INTEGER )           : BOOLEAN; C;
FUNCTION  num_drive                      : INTEGER; C;
FUNCTION  format( d, t : INTEGER )       : BOOLEAN; C;

{=========================================================================

        FmtDsk( Drive, Type )
                Format a disk in drive a or b of type Type (see above)
                Returns FALSE if not able to format disk, or
                TRUE if all is well.

==========================================================================}

FUNCTION FmtDsk( Drive : Flop_Typ; Typ : Fmt_Typ ) : BOOLEAN;

   Begin
      FmtDsk := format( Drive, Typ );
   End;

{=========================================================================

        WrtVer( Func ) sets / inquires status of write verify flag on
        floppy disk systems.
        returns TRUE if write verify is on, else FALSE

==========================================================================}


FUNCTION WrtVer( Func : VerTyp ) : BOOLEAN;

   Begin
      WrtVer := verify( Func ); { return verify status, and set if nessecary }
   End;


{=========================================================================

        IsDrive( dnum ) returns TRUE if drive DNUM is an installed drive.
        this is NOT reliable in the case of installable devices such as
        ramdisks or hard drives, since <resetting> the computer DOES NOT
        tell the system to clear out this info.

===========================================================================}

FUNCTION IsDrive( Dnum : Drv_Range ) : BOOLEAN;

   Begin
      IsDrive := is_drive( Dnum );
   End;



{=========================================================================

        NumDriv returns the number of floppy disk drives connected.

==========================================================================}

FUNCTION NumDriv : Flop_Typ;

   Begin
      NumDriv := num_drive;
   End;


Begin
End.

